/*
 * Copyright (c) 1981 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef lint
static char sccsid[] = "@(#)scanw.c	5.3 (Berkeley) 6/30/88";
#endif /* not lint */

/*
 * scanw and friends
 *
 */

# include	"curses.ext"
# include	<stdarg.h>

/*
 *	This routine implements a scanf on the standard screen.
 */
scanw(char *fmt, ...) {
	va_list args;
	va_start(args, fmt);
	return _sscans(stdscr, fmt, args);
}
/*
 *	This routine implements a scanf on the given window.
 */
wscanw(WINDOW *win, char *fmt, ...) {
	va_list args;
	va_start(args, fmt);
	return _sscans(win, fmt, args);
}
/*
 *	This routine actually executes the scanf from the window.
 *
 *	This is really a modified version of "sscanf".  As such,
 * it assumes that sscanf interfaces with the other scanf functions
 * in a certain way.  If this is not how your system works, you
 * will have to modify this routine to use the interface that your
 * "sscanf" uses.
 */
_sscans(win, fmt, args)
WINDOW	*win;
char	*fmt;
va_list	args; {

	char	buf[100];

	if (wgetstr(win, buf) == ERR)
		return ERR;
	return vsscanf(buf, fmt, args);
}
